/***************************************************************************
                          MiniXML.h  -  description
                             -------------------
    begin                : Sun Apr 21 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _MINIXML_H_
#define _MINIXML_H_

#define MINIXML_VERSION "0.5"

#include "Element.h"

#define NEW_TAG_STATE 0
#define GET_TAG_NAME_STATE 1
#define GET_ATTR_NAME_STATE 2
#define GET_ATTR_VALUE_STATE 3
#define GET_TAG_VALUE_STATE 4
#define NEW_SUB_TAG_STATE 5
#define GET_END_TAG_NAME_STATE 6
#define TAG_END_STATE 7
#define TAG_COMMENT_STATE 8
#define TAG_DECLARATION_STATE 9

#define OUT_STR_BLOCK 1024

class MiniXML
{
	private:
		Element *mXmlTree;
		char *mOutStr;
		int mOutStrBlocks;
		int mFirstCall;

	private:
		char *CleanUpString(char *);
		char *Parse(char *, Element *);
		void AddOutStrBlocks(int);

	public:
		MiniXML();
		~MiniXML();

		void DropTree();
		Element *GetTree() { return mXmlTree; } ;
		void Parse(char *);
		void ParseFile(const char *);
		char *GetOutStr() {return mOutStr;};
		void InitOutStr();
		void Tree2Str(Element *);

};//MiniXML

#endif

