/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sun Apr 21 09:32:58 CEST 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html
 *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include "MiniXML.h"
#include "MiniXmlDefines.h";

int main(int argc, char *argv[])
{
	MiniXML miniXML;
	FILE *fd;
	char *strPtr, *xmlStr, str[OUT_STR_BLOCK];
	Element *tree, *subTree;
	ElementAttribute *attr;
	int blocks;

	// Control if we have a file name
	if (argc <2) {
		printf("Missing file name\n");
		return 1;
	}

	// Open and read the file into a string
	if ((fd=fopen(argv[1],"r"))==NULL) {
		printf("Can't open the file: %s\n",argv[1]);
		return 1;
	}
	xmlStr = (char*)malloc(OUT_STR_BLOCK);
	blocks = 1;
	*xmlStr = '\0';
	while (fgets(str, OUT_STR_BLOCK, fd)) {
		if ((strlen(xmlStr)+strlen(str)+1) > (unsigned int)(blocks*OUT_STR_BLOCK)) {
			char *newStr;
			blocks++;
			newStr = (char *)malloc(blocks*OUT_STR_BLOCK);
			strcpy(newStr, xmlStr);
			free(xmlStr);
			xmlStr = newStr;
		}
		strcat(xmlStr, str);
	}
	fclose(fd);

	// Parse the readed string and get the XML document tree
	miniXML.Parse(xmlStr);
	tree = miniXML.GetTree();
	// Print the whole tree the ouput schold be equal to the file we read
	miniXML.InitOutStr();
	miniXML.Tree2Str(tree);
	free(xmlStr);
	xmlStr = miniXML.GetOutStr();
	printf("%s\n\n",xmlStr);

	// Lets start to do some searches for tags within the XML document tree
	tree->InitSearch();
	do {
		subTree = tree->SearchFor("pool");
		if (subTree==NULL) printf("NULL tree!\n");
		else {
			// Print the value for the searched tag
			if ((strPtr=subTree->GetName())!=NULL) printf("Name: %s\n",strPtr);
			if ((strPtr=subTree->GetValue())!=NULL) printf("Value: %s\n",strPtr);
			// Print all attrbute for the actual tag
			if ((attr=subTree->GetAttributes())!=NULL) {
				printf("All attributes:\n");
				while (attr) {
					if (attr->mName!=NULL) {
						printf("  %s = ",attr->mName);
						if (attr->mValue!=NULL) printf("%s\n",attr->mValue);
						else printf("\n");
					}
					attr = attr->mNext;
				}
				printf("Ask for spcific attrbute:\n");
				if ((strPtr=subTree->GetAttrubuteValue("attr2"))!=NULL) printf("  attr2=%s\n",strPtr);
			}
			// Print the whole sub stree in a XML format
			miniXML.InitOutStr();
			miniXML.Tree2Str(subTree);
			xmlStr = miniXML.GetOutStr();
			printf("%s\n\n",xmlStr);
		}
	} while (subTree);

	printf("MiniXML test end!\n");
	return 0;
}
